%%%%%%%%%%% CSC 320 A1 2005 Sample solutions

%%%%%%%%%%%%%%%%%%%%%%% Question 1 %%%%%%%%%%%%%%%%%%%%%%%%%%%%
N =16;  % Must be even and bigger than 5

%%%%% Q1a

% Define f and g
x = 0:(N-1);
f = zeros(1, N);
f(N/2+1) = 1; f(N/2+2) = -1;

% DFTs of f and g
dftf = fftshift(fft(f));
k = [-N/2:(N/2-1)];

hand = 2*i*exp(-i*pi*k/N*(N+1)).*sin(pi*k/N);

%% Amplitude spectrum
figure(1); clf;
plot(k, abs(dftf),'-b');
hold on;
plot(k, abs(hand), '-g');
pause;

%% Real and Imaginary parts
figure(1); clf;
subplot(1,2,1);
plot(k, real(dftf),'-b');
hold on;
plot(k, real(hand), '-g');
subplot(1,2,2);
plot(k, imag(dftf),'-b');
hold on;
plot(k, imag(hand), '-g');
pause;
  
%%%%% Q1b
x = 0:(N-1);
f = zeros(1, N);
f(N/2+1) = 2; f(N/2) = -1; f(N/2+2) = -1;

dftf = fftshift(fft(f));
k = [-N/2:(N/2-1)];
hand = 2*exp(-i*2*pi*k/N*(N/2)).*(1-cos(2*pi*k/N));

%% Amplitude spectrum
figure(1); clf;
plot(k, abs(dftf),'-b');
hold on;
plot(k, abs(hand), '-g');
pause;

%% Real and Imaginary parts
figure(1); clf;
subplot(1,2,1);
plot(k, real(dftf),'-b');
hold on;
plot(k, real(hand), '-g');
subplot(1,2,2);
plot(k, imag(dftf),'-b');
hold on;
plot(k, imag(hand), '-g');
pause;

 
%%%%% Q1c
x = 0:(N-1);
f = zeros(1, N);
f(N/2+1+[-2:2]) = 1; 

dftf = fftshift(fft(f));
k = [-N/2:(N/2-1)];
hand = (1 + 2*cos(2*pi*k/N)+2*cos(4*pi*k/N)).*exp(-i*pi*k);

%% Amplitude spectrum
figure(1); clf;
plot(k, abs(dftf),'-b');
hold on;
plot(k, abs(hand), '-g');
pause;

%% Real and Imaginary parts
figure(1); clf;
subplot(1,2,1);
plot(k, real(dftf),'-b');
hold on;
plot(k, real(hand), '-g');
subplot(1,2,2);
plot(k, imag(dftf),'-b');
hold on;
plot(k, imag(hand), '-g');
pause;

